#SingleInstance force
;If you have any questions, contact Selune in Meroe
SetDefaultMouseSpeed 0


!F1::
; Reset the script
reload
return


!q::
; Emergency Quit
ExitApp
return

!p::
; Pause the script
Pause
return


!s::
; Toggle hotkeys
suspend toggle
return


!m::
; Mine
Gui, Add, Text,, Metal to Mine:
Gui, Add, DropDownList, vmetal Choose2, iron|copper|tin
Gui, Add, Text,, Number of times to repeat:
Gui, Add, Edit, vnum_repeats wp, 50
Gui, Add, Text,, Mining timer in seconds (decimals OK):
Gui, Add, Edit, vclick_delay wp, 5
Gui, Add, Text,, Ore Extraction level:
Gui, Add, DropDownList, vskill Choose1, 1|2|3|4|5|6
Gui, Add, Button, Default, MINE
Gui, Show
return

;For later
;Gui, Add, Text,, This option is a work in progress, to allow you to type normally while mining`n
;	. By default the macro will send Ws, so chat must be closed`n
;	. With ImageSearch, it will search for and try to click Work
;Gui, Add, Checkbox, vsearch, Imagesearch
;Gui, Add, Text,, Imagesearch variance (try 100 if 50 doesn't work)
;Gui, Add, Edit, vvariance wp, 50


ButtonMINE:
Gui, Submit
; Validate input
if (!((num_repeats > 0) && (num_repeats <= 10000))) { 
	MsgBox "Please enter a number of repeats between 1 and 10000"
	Gui, Show
	return
}
if (!((click_delay >= 0) && (click_delay <= 7))) { 
	MsgBox "Please enter a mining timer between 0 and 7 seconds"
	Gui, Show
	return
}

if ((metal != "copper") && (metal != "iron")) {
	; For now
	MsgBox "Only copper and iron supported!"
	Gui, Show
	return

	; For later
	skill = 5
}

; Make sure repeat is an integer
num_repeats //= 1

; Convert to miliseconds
click_delay *= 1000

Gui, Destroy
Mine()
return


Mine()
{
	global skill
	global metal
	global click_delay
	global num_repeats
	global search
	global variance

	debug = 0
	round = 1
	crystal = 0

	; Get the locations of the crystals
	MsgBox "Move the mouse to each crystal, and press F1`nFor best results, choose a spot of equal lightness on each crystal"
	Loop 7 {
		KeyWait, F1, D
		KeyWait, F1
		crystal += 1
		MouseGetPos, Xtemp, Ytemp
		X%crystal% := Xtemp
		Y%crystal% := Ytemp
	}

	; Set some defaults in case you need to delay for higher skill levels
	i = 0
	Loop 7 {
		i += 1
		memory%i% = 4
	}

	; Do work
	Loop %num_repeats% {
		i = 0
		num = 0

		; Collect color information on all the crystals
		Loop 7 {
			i += 1
			PixelGetColor, color%i%, X%i%, Y%i%, Alt
			R%i% := color%i% & 0xFF0000
			R%i% >>= 16
			G%i% := color%i% & 0x00FF00
			G%i% >>= 8
			B%i% := color%i% & 0x0000FF
			Sleep 5

			; Convert RGB into HSL (Hue, Saturation, Lightness)
			; They're float numbers I swear
			R%i% /= 255.0
			G%i% /= 255.0
			B%i% /= 255.0

			minimum%i% := Min(Min(R%i%, G%i%), B%i%)
			maximum%i% := Max(Max(R%i%, G%i%), B%i%)

			; Lightness
			lightness%i% := (maximum%i% - minimum%i%)/2

			; Saturation
			saturation%i% := ((maximum%i% - minimum%i%)/maximum%i%) * 100

			; Hue
			if (R%i% == maximum%i%) {
				hue%i% := (G%i%-B%i%)/(maximum%i%-minimum%i%)
			} else if (G%i% == maximum%i%) {
				hue%i% := 2.0 + (B%i%-R%i%)/(maximum%i%-minimum%i%)
			} else if (B == maximum%i%) {
				hue%i% := 4.0 + (R%i%-G%i%)/(maximum%i%-minimum%i%)
			}

			if (hue%i% < 0) {
				hue%i% += 6
			}
		}

		; The "correct" crystal for copper is the one with the highest saturation
		if (metal == "copper") {
			i = 0
			max_sat = 0
			Loop 7 {
				i += 1
				if (saturation%i% > max_sat) {
					max_sat := saturation%i%
					num := i
				}
			}
		}

		; Find the biggest single difference in color
		if (metal == "iron") {
			i = 0
			
			; Find a comparison crystal
			if (IsClose(R1, R2) && IsClose(G1, G2) && IsClose(B1, B2)) {
				; Comparison found
				basis = 1
			} else {
				if (IsClose(R1, R3) && IsClose(G1, G3) && IsClose(B1, B3)) {
					; 1 is a valid comparison
					basis = 1
				} else {
					; 2 is a valid comparison
					basis = 2
				}
			}

			; Compare all crystals to the basis, and find the single largest difference
			max_diff = 0
			Loop 7 {
				; Skip comparing it with itself
				if (A_Index == basis) {
					continue
				}
				
				; Compare values
				Rdiff := Abs(R%A_Index% - R%basis%)
				Gdiff := Abs(G%A_Index% - G%basis%)
				Bdiff := Abs(B%A_Index% - B%basis%)

				temp := Max(Max(Rdiff, Gdiff), Bdiff)
				if (temp > max_diff) {
					max_diff := temp
					num := A_Index
				}
			}
		} ; end of "Iron"

		if (metal == "tin") {
			
		}

		if (metal == "lead") {
			
		}

		if (metal == "tungsten") {
			
		}

		if (metal == "titanium") {
			
		}

		memory%round% := num
		round += 1
		if (round > skill) {
			round := 1
		}
		num := memory%round%

		if (debug) {
			Message := ""
			i = 0
			loop 7 {
				i += 1
				Message .= i . ": R=" . R%i% . ", G=" . G%i% . ", B=". B%i% . ", Avg=" . A%i%
					     . " H=" . hue%i% . " S=" . saturation%i% . " L=" . lightness%i% . "`n"
			}
			Message .= "Max is " . num . "`n`n"
			FileAppend, %Message%, C:\atitd.log
		}

		; Option to either send w or use the imagesearch
		if (search == true) {
			Work(X%num%, Y%num%)
		} else {
			MouseMove, X%num%, Y%num%
			Sleep 60
			Send w
		}

		Sleep %click_delay%
	}
}


Work(x, y)
{
	MouseMove, x, y
	Sleep 30
	MouseClick, Right
	Sleep 60
	ImageSearch, foundX, foundY, x, (y - 60), (x + 200), (y + 60), *%variance% Find_Work.png
	if (errorlevel == 0) {
		MouseMove, (foundX + 5), (foundY + 2)
		Sleep 40
		MouseClick, Right
	} else if (errorlevel == 2) {
		MsgBox ZOMG BROKEN
	}
}


Max(x, y)
{
	return x > y ? x : y
}


Min(x ,y)
{
	return x < y ? x : y
}

IsClose(a, b)
{
	return ((Abs(a - b) < min_diff) ? 1 : 0)
}

GuiClose:
Gui, Destroy
return